"""Cryptopy Version 3
Crypte et decrypte un texte en chiffrement Cesar.
Sait travailler avec le contenu d'un fichier texte.
Brendan Scott, 2022 VF par OE
"""

#### Imports
import string

#### Constantes
JEUCAR = string.printable[:-5]
CARSUBSTI = JEUCAR[-3:]+JEUCAR[:-3]
MSG_TEST = "J'adore les Monty Python. Trop cool."

# Generation du dictionnaire avec les deux jeux de caracteres
# (en clair et substitutions).
DICO_ENCRYP = {}
DICO_DECRYP = {}
for i,k in enumerate(JEUCAR):
    v = CARSUBSTI[i]
    DICO_ENCRYP[k] = v
    DICO_DECRYP[v] = k
# Les autres  \t, \n etc. restent tels quels
for c in string.printable[-5:]: # Attention aux deux points
    DICO_ENCRYP[c] = c
    DICO_DECRYP[c] = c
    
#### Fonctions
def encrypter(texteclair, vardico_cryp):
    """ Crypte le message texteclair avec le dictionnaire
    fourni et renvoie le texte une fois rendu illisible. """
    textesecret = []
    for k in texteclair:
        v = vardico_cryp[k]
        textesecret.append(v)
    return ''.join(textesecret)

def decrypter(textesecret, vardico_decryp):
    """ Decrypte le message avec le dictionnaire
    fourni et renvoie le texte une fois rendu lisible. """
    texteclair = []
    for k in textesecret:
        v = vardico_decryp[k]
        texteclair.append(v)
    return ''.join(texteclair)

#### Section principale et de test
msg_testeur = MSG_TEST #JEUCAR            # ou MSG_TEST
textesecret = encrypter(msg_testeur, DICO_ENCRYP)
texteclair  = decrypter(textesecret, DICO_DECRYP)

print(msg_testeur)
print(textesecret)
print(texteclair)
print(texteclair == msg_testeur)

