"""
carnet.py  Version 8 (avec le Kontroleur)
Gestion de fiches de contacts avec
prenom, nom, naissance, courriel (email)
Brendan Scott 2022 VF par OE
"""

### Section Imports
import pickle as saumure
import os.path             #AJOUT

### Section Constantes
NOMFIC_SAUVE = "carnet.pickle"

### Section Classes
class CarnetAdr(object):
    """ Conteneur de fiches
    METHODES : __init__,ajouter_fiche(), sauver()
    """
    def __init__(self):
        """ Cree l'attribut gens comme liste vide.
        """
        self.gens = []

    def ajouter_fiche(self, fiche_nouvo):
        """ Ajoute une fiche dans gens.
        """
        self.gens.append(fiche_nouvo)

    def sauver(self):
        with open(NOMFIC_SAUVE,'wb') as ficow:
            saumure.dump(self, ficow)

class FicheAdr(object):
    """ Fiche d'un contact.
    METHODES : __init__, __repr__
    """
    def __init__(self, prenom=None, nomfami=None,
                 datenaiss=None, courriel=None):
        """Initialise les 4 attributs.
        """
        self.prenom    = prenom
        self.nomfami   = nomfami
        self.datenaiss = datenaiss
        self.courriel  = courriel

    def __repr__(self):
        """ Produit une chaine selon l'objet
        FicheAdr fourni en argument self.
        """
        patron = "FicheAdr(prenom ='%s', "+\
             "nomfami ='%s',"+\
             "datenaiss ='%s', "+\
             "courriel ='%s')"
        return patron%(self.prenom,self.nomfami,
                       self.datenaiss,self.courriel)

class Kontroleur(object):  #AJOUT de toute la classe
    """ Pour gerer les donnees stockees dans une
    instance de CarnetAdr, le menu et le chargement
    des donnees du fichier.
    METHODES : __init__, charger()
    """
    def __init__(self):
        """
        Initialise le controleur. Cherche un fichier.
        S'il le trouve, il le lit. Sinon, il cree un
        fichier vide.
        """
        self.carnet_adr = self.charger()           #AJOUT
        if self.carnet_adr is None:             #AJOUT
            self.carnet_adr = CarnetAdr()       #MODIF
        # contact1 = FicheAdr("Eric", "IDLE", "2001/06/12", None)
        # self.carnet_adr.ajouter_fiche(contact1)

    def charger(self):
        """
        Charge un carnet depuis un fichier pickle.
        """
        if os.path.exists(NOMFIC_SAUVE):           #AJOUT
            with open(NOMFIC_SAUVE, 'rb') as ficor: #MODIF
                return saumure.load(ficor)          #MODIF
        else:                                      #AJOUT
            return None                            #AJOUT

### Section Fonctions

### Section principale main
if __name__ == "__main__":
    controleur = Kontroleur()           #AJOUT
    print(controleur.carnet_adr.gens)   #MODIF
    #SUPPR Autres lignes devenues inutiles
