"""
tablesmul.py Version 7 (avec menu)
Les tables de multiplication
Brendan Scott VF par OE
"""

#### Section des imports
import random

#### Section des constantes
Q_TEST = (4, 6)
PATRON_Q = "Combien font %s x %s ? "
MINI  = 1
MAXI  = 12
Q_MAX = 3
LIGNE_TMUL = "%2i x %2i = %3i "
INSTRUCTIONS = """
**********************************************
    Application Tables de multiplication
(Python en s'amusant Pour les Nuls, Projet 10)
**********************************************
Permet de s'exercer aux tables de multiplication
entre 1 et 12 et d'afficher les tables.
""" #AJOUT V7

#### Section des fonctions
def creer_listeq(nmin = MINI, nmax = MAXI, hasard=True): #MODIF V3
    """ Produit une liste de questions au format (x,y)
    avec x et y entre MINI et MAXI (compris)
    """
    tempo = [(x+1, y+1) for x in range(nmin-1, nmax)
                        for y in range(nmin-1, nmax)]
    if hasard:
        random.shuffle(tempo)
    return(tempo)

def faire_test():                  #AJOUT V4
    """ Lance une passe de test """
    liste_q = creer_listeq()
    score = 0
    for i, question in enumerate(liste_q):
        if i >= Q_MAX:
            break
        invite = PATRON_Q%question
        repon_ok = question[0]*question[1]
        # Les indices commencent a 0
        repon_saisie = input(invite)

        if int(repon_saisie) == repon_ok:
            print("Correct !")
            score = score+1
        else:
            print("Incorrect, il fallait trouver %s."%(repon_ok))

    print("Nombre de calculs corrects : %s"%score)

def afficher_tablesmul(nmax = MAXI): #REFONTE V6
    # Affiche la table des mult. jusque MAXI
    tab_par_lig = 5
    tab_total = list(range(1, nmax+1))      # Python 3 !
    # Prend un lot de 5 pour affichage
    lot_tab = tab_total[:tab_par_lig]
    # Les enleve du stock restant
    tab_total = tab_total[tab_par_lig:]
    while lot_tab: # Stop quand vide
        for x in range(1, nmax+1):
            # Lignes vont de 1 a 12
            accumul = []
            for y in lot_tab:
                # Construit les colonnes
                accumul.append(LIGNE_TMUL%(y, x, x*y))
            print("".join(accumul)) # Affiche une ligne
        print("\n") # Separation verticale entre blocs de tables
        # Lot suivant
        lot_tab = tab_total[:tab_par_lig]
        tab_total = tab_total[tab_par_lig:]

def quitter():  #AJOUT V7
    """ Pour quitter l'application"""
    print("Dans quitter()")

#### Section principale (et de test)
# Onze lignes supprimees
# faire_test()
# afficher_tablesmul()         #MODIF V7

#### Section principale "main"
if __name__ == "__main__":
    while True:
        print(INSTRUCTIONS)
        menu_txt = "Choisis: 1 pour reviser,"+\
                        " 2 pour t'exercer, 3 pour quitter.\n"
        menu_choix = input(menu_txt)
        menu_choix = menu_choix.strip()
        while menu_choix not in ["1", "2", "3"]:
            menu_choix = input("Seulement 1, 2 ou 3: ")
            menu_choix = menu_choix.strip()
        if menu_choix == "1":
            afficher_tablesmul()
        elif menu_choix == "2":
            faire_test()
        else: # Doit etre 1, 2 ou 3, donc c'est 3 pour quitter
            quitter()
