# P14_Couleurs.py
# inspired by https://blog.teclado.com/tkinter-scrollable-frames/

import tkinter as tk
from   tkinter import ttk

liscoul = []

def charger_liste(liste):
    with open('P14_CoulData.txt', 'r') as fic:
        for ligne in fic:
            coul = ligne[:-1] # oter le carac de saut de ligne
            liscoul.append(coul)


racine    = tk.Tk()
conteneur = ttk.Frame(racine)
canevas   = tk.Canvas(conteneur, width=1000, height=900)
barre = ttk.Scrollbar(conteneur, orient="vertical", command=canevas.yview)
scrollable_frame = ttk.Frame(canevas)

scrollable_frame.bind(
    "<Configure>",
    lambda e: canevas.configure(
        scrollregion=canevas.bbox("all")
    )
)
canevas.create_window((0, 0), window=scrollable_frame, anchor="nw")
canevas.configure(yscrollcommand=barre.set)

charger_liste(liscoul)

for c in liscoul:
    ttk.Label(scrollable_frame, text = c, background = c, width=500).pack()
   
conteneur.pack()
canevas.pack(side="left", fill="both", expand=True)
barre.pack(side="right", fill="y")

racine.mainloop()


